/* 
 * FILE --- matrix_ex.cc
 */

// Include Files
#include <stdio.h>
#include "matrix.hh"


void main(void) {

  int ii, jj;

  double aa;
  double tt1[3] = {1.0, 2.0, 3.0}; 
  double tt2[3] = {0.0, 1.0, 4.0}; 

  matrix A(2,3);
  matrix B;

  A.set_row(0, tt1);
  A.set_row(1, tt2);

  printf("The initial matrix is:\n");
  for (ii = 0; ii < A.get_num_rows(); ii++)
    {
      for (jj = 0; jj < A.get_num_cols(); jj++)
	printf("%f  ", A.get_element(ii,jj)); 
      printf("\n");
    }
  getchar();

  // Take the transpose
  printf("\nIts transpose is:\n");
  B = transpose(A);
  for (ii = 0; ii < B.get_num_rows(); ii++)
    {
      for (jj = 0; jj < B.get_num_cols(); jj++)
	printf("%f  ", B.get_element(ii,jj));
      printf("\n");
    }
  getchar();

  // Take the pseudo inverse
  printf("\nIts pseudo inverse is:\n");
  B = pinv(A);
  for (ii = 0; ii < B.get_num_rows(); ii++)
    {
      for (jj = 0; jj < B.get_num_cols(); jj++)
	printf("%f  ", B.get_element(ii,jj));
      printf("\n");
    }
  getchar();

  // Take the inverse of A*A'
  printf("\nThe inverse of A*A' is:\n");
  B = inv(A * transpose(A));
  for (ii = 0; ii < B.get_num_rows(); ii++)
    {
      for (jj = 0; jj < B.get_num_cols(); jj++)
	printf("%f  ", B.get_element(ii,jj));
      printf("\n");
    }
  getchar();

  // Take the inverse of A'*A
  printf("\nThe inverse of A'*A is:\n");
  B = inv(transpose(A) * A);
  for (ii = 0; ii < B.get_num_rows(); ii++)
    {
      for (jj = 0; jj < B.get_num_cols(); jj++)
	printf("%f  ", B.get_element(ii,jj));
      printf("\n");
    }
  getchar();

  // Premultiply by a scalar
  printf("\nPremultiply it by 2.0:\n");
  B = 2.0 * A;
  for (ii = 0; ii < B.get_num_rows(); ii++)
    {
      for (jj = 0; jj < B.get_num_cols(); jj++)
	printf("%f  ", B.get_element(ii,jj));
      printf("\n");
    }
  getchar();

  // Postmultiply by a scalar
  printf("\nPostmultiply it by 3.0:\n");
  B = A * 3.0;
  for (ii = 0; ii < B.get_num_rows(); ii++)
    {
      for (jj = 0; jj < B.get_num_cols(); jj++)
	printf("%f  ", B.get_element(ii,jj));
      printf("\n");
    }
  getchar();

  // Check the inverse
  printf("\nThis should be identity:\n");
  B = A*pinv(A);
  for (ii = 0; ii < B.get_num_rows(); ii++)
    {
      for (jj = 0; jj < B.get_num_cols(); jj++)
	printf("%f  ", B.get_element(ii,jj));
      printf("\n");
    }
  getchar();

  // Find its norm
  aa = norm(A);
  printf("\nIts norm is: %f\n",aa);
  getchar();

  // Find its trace
  aa = trace(A);
  printf("\nIts trace is: %f\n",aa);
  getchar();
}
